Description

When one or more issues are copied, the relations get lost. This is especially annoying when a structure of issues with
precedes/follows or blocks/blocked by relations gets copied.

To clarify this, especially when a list of issues gets copied, there are two possible types of relations:

e the relations which are inside the copied structure
¢ the relations that point out of the copied structure

In my opinion the first type (inner relations) should be automatically mapped to the new created (copied) structure.
This would be the same behavior as when a complete project is copied. For the second type it could also be reasonable to have a
setting in the bulk-copy page like "Copy outer relations”, if such relations are existing in the selected structure.

| think this bugfix would even resolve request #11647 to some extent, because then it would be possible to create one
"template"-project from which frequently used structures (e.g. like a software release procedure etc.) could always be copied by the
users to their "real" projects.

Related issues:

Related to Redmine - Feature #11647: Create Issue Structure Templates New
Has duplicate Redmine - Patch #42081: Copying following tasks New
History

#1 - 2013-07-10 07:28 - Michael Heinze

+1

#2 - 2013-07-10 08:34 - Etienne Massip
- Tracker changed from Defect to Feature
- Subject changed from Relations are not copied to Copy inner issues relations along with issues

- Target version set to Candidate for next major release

#3 - 2013-10-03 23:21 - Dirk Schmidt

+1

#4 - 2013-10-08 06:44 - Toshi MARUYAMA
- Related to Feature #11647: Create Issue Structure Templates added

#5 - 2014-01-09 02:15 - Matthew Houston

This would also be useful to us. we use a structure of issus -> child issues with set proceeds/follows as a template which is copied. At the moment
the users just re-add the relationships manually but it would def add convenience to be able to maintain that.

#6 - 2014-03-04 13:42 - Mahyar Ahmadpour-B.

+1
| suggest all proceed/follow relations should be copied. Also it would be perfect if there was an option to enable/disable creation of copied to/from
relations.

#7 - 2015-08-25 07:43 - Thomas Pihl

+1
https://www.redmine.org/issues/11647

Much needed!

#8 - 2015-08-25 11:08 - Sebastian Paluch

+1

#9 - 2016-11-18 17:01 - Hal Glenn

still important and relevant

#10 - 2016-12-02 14:59 - Jonata Bolzan Loss

+1

#11 - 2019-01-07 12:03 - Jakub Shanel

It would be great, this feature missing me a lot

#12 - 2020-05-14 14:39 - Philippe Vaucher

This is how | do it in one of my private plugins:

# Import issues

ids = @source.issues.roots.order (:id) .map do |old_issue]|
new_issue = old_issue.copy ({ project: @project, notify: false }, { link: false })
new_issue.save!
[old_issue.id, new_issue.id]

end.to_h

# Recreate relations
@source.issues.roots.order (:id) .each do |old_issue]|
old_issue.relations_from.each do |relation]|

attributes = relation.attributes.except ('id"')
attributes['issue_from_id'] = ids[attributes['issue_from_id']]
attributes['issue_to_id'] = ids[attributes['issue_to_id']]
IssueRelation.create! (attributes)
end
end

| don't have time to make a patch for Issue#copy, but above code should be simple enough for others to be able to make a patch out of it.

#13 - 2021-06-30 12:53 - Mike Furminsky

Selling a soul for this very necessary functionality. If someone made a patch, please share.
Redmine 4.1.1

#14 - 2024-10-07 10:55 - Brice Beaumesnil

+1

#15 - 2025-01-08 10:03 - Alfredo Renzetti
See #42081

#16 - 2025-04-14 07:16 - Marius BALTEANU
- Has duplicate Patch #42081: Copying following tasks added
